local SKIN = "ovasonic"

local spinsounds = {
	sfx_s3kab,
	sfx_s3kab1,
	sfx_s3kab2,
	sfx_s3kab4,
	sfx_s3kab5
}

addHook("PlayerThink", function(p)
	if not(p.mo and p.mo.valid and p.mo.skin == SKIN) then return end
	
	if P_IsObjectOnGround(p.mo) or p.wallrun
		p.storespeed = 0
		p.abiltimer = 0
		p.soundDone = false
	end
	
	if p.pflags&PF_JUMPED and p.pflags&PF_THOKKED and not(p.pflags&PF_SHIELDABILITY)
		if p.abiltimer > 0 and p.abiltimer < TICRATE*19/4
			if p.cmd.buttons&BT_JUMP
				p.abiltimer = $+1
				P_SetObjectMomZ(p.mo, 0)
				P_InstaThrust(p.mo, p.startangle, p.speed*3/4)
				if p.abiltimer % TICRATE == 0
					S_StartSound(p.mo, spinsounds[p.abiltimer/TICRATE])
				end
				if p.abiltimer == TICRATE*4
					S_StartSound(p.mo, sfx_spin)
					local g = P_SpawnGhostMobj(p.mo)
					g.destscale = FRACUNIT*3/2
					g.colorized = true
				end
			else
				local force
				if p.abiltimer < TICRATE
					force = 16
				elseif p.abiltimer < TICRATE*2
					force = 20
				elseif p.abiltimer < TICRATE*3
					force = 24
				elseif p.abiltimer < TICRATE*4
					force = 28
				else
					force = 32
				end
				S_StartSound(p.mo, sfx_zoom)
				S_StopSoundByID(p.mo, sfx_kc36)
				if p.abiltimer > TICRATE*2
					S_StartSound(p.mo, sfx_kc5b)
				end
				p.pflags = $ & ~(PF_THOKKED|PF_SPINNING)
				P_SetObjectMomZ(p.mo, force*FRACUNIT)
				P_InstaThrust(p.mo, p.mo.angle, p.storespeed)
				p.mo.state = S_PLAY_SPRING
				p.abiltimer = TICRATE*19/4
				for i = 1, 18 do
					local fx = P_SpawnMobjFromMobj(p.mo, 0,0,-FRACUNIT, MT_SPINDUST)
					fx.source = p.mo
					fx.angle = p.mo.angle+((ANG20*i)+P_RandomKey(3)*ANG20)
					P_InstaThrust(fx, fx.angle, FRACUNIT*24)
					fx.momz = -FRACUNIT
					fx.spin = true
				end
			end
		else
			if not p.soundDone
				S_StartSound(p.mo, sfx_kc65)
				p.soundDone = true
			end
			p.mo.state = S_PLAY_FALL
		end
	end
end)

addHook("AbilitySpecial", function(p)
	if not(p.mo and p.mo.valid and p.mo.skin == SKIN) then return end
	
	if not p.abiltimer
		p.storespeed = p.speed
		S_StartSound(p.mo, sfx_s3kab)
		p.pflags = $|PF_THOKKED
		p.abiltimer = 1
		p.startangle = p.drawangle
	end
end)

addHook("MobjThinker", function(m)
	if not m.spin then return end
	
	P_InstaThrust(m, m.angle, FRACUNIT*4)
end, MT_SPINDUST)